



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ 1149 PIGS ★(经典网络流构图)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ 1149 PIGS ★(经典网络流构图)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 14:18:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>【题意】 有M个猪圈，每个猪圈里初始时有若干头猪。一开始所有猪圈都是关闭的。依 次来了N个顾客，每个顾客分别会打开指定的几个猪圈，从中买若干头猪。每 个顾客分别都有他能够买的数量的上限。每个顾客走后，他打开的那些猪圈中的 猪，都可以被任意地调换到其它开着的猪圈里，然后所有猪圈重新关上。问总共 最多能卖出多少头猪。（1 &lt;= N &lt;= 100, 1 &lt;= M &lt;= 1000）</p>
<p>非常好的一道网络流建模题！最大的收获就是：</p>
<p><strong>在面对网络流问题时，如果一时想不出很好的构图方法，不如先构造一个最</strong><br />
<strong>直观，或者说最“硬来”的模型，然后再用合并结点和边的方法来简化这个模</strong><br />
<strong>型。经过简化以后，好的构图思路自然就会涌现出来了。这是解决网络流问题</strong><br />
<strong>的一个好方法。</strong></p>
<p>－－－以下思路来自于Edelweiss大牛的《网络流建模汇总》</p>

<p>【建模方法】 不难想象，这个问题的网络模型可以很直观地构造出来。就拿上面的例子来说， 可以构造出图1所示的模型（图中凡是没有标数字的边，容量都是∞）： • 三个顾客，就有三轮交易，每一轮分别都有3个猪圈和1个顾客的结点。 • 从源点到第一轮的各个猪圈各有一条边，容量就是各个猪圈里的猪的初始 数量。 • 从各个顾客到汇点各有一条边，容量就是各个顾客能买的数量上限。 • 在某一轮中，从该顾客打开的所有猪圈都有一条边连向该顾客，容量都是 ∞。 • 最后一轮除外，从每一轮的i 号猪圈都有一条边连向下一轮的i 号猪圈， 容量都是∞，表示这一轮剩下的猪可以留到下一轮。 • 最后一轮除外，从每一轮被打开的所有猪圈，到下一轮的同样这些猪圈， 两两之间都要连一条边，表示它们之间可以任意流通。</p>
<p>这个网络模型的最大流量就是最多能卖出的数量。图中最多有<br />
2+N+M×N≈100,000个结点。这个模型虽然很直观，但是结点数太多了，计算速<br />
度肯定会很慢。其实不用再想别的算法，就让我们继续上面的例子，用合并的方<br />
法来简化这个网络模型。<br />
首先，最后一轮中没有打开的猪圈就可以从图中删掉了，也就是图中红色<br />
的部分，显然它们对整个网络的流量没有任何影响。</p>
<p><img referrerpolicy="no-referrer"src="http://www.abandonzhang.com/wp-content/uploads/2013/07/360截图20120723165932194.jpg" /></p>

<p>再根据下面<strong>网络流节点合并规律</strong>：</p>

<p><img referrerpolicy="no-referrer"src="http://www.abandonzhang.com/wp-content/uploads/2013/07/构图点合并.jpg" /></p>

<p>得到最终的图：</p>
<p><img referrerpolicy="no-referrer"src="http://www.abandonzhang.com/wp-content/uploads/2013/07/22.jpg" /></p>

<p>总结本题的构图规则就是：</p>
<p><img referrerpolicy="no-referrer"src="http://www.abandonzhang.com/wp-content/uploads/2013/07/223.jpg" /></p>
<pre class="prettyprint linenums">
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#include<br />
#define MID(x,y) ((x+y)/2)<br />
#define mem(a,b) memset(a,b,sizeof(a))<br />
using namespace std;<br />
const int MAXV = 305;<br />
const int MAXE = 10005;<br />
struct node{<br />
    int u, v, flow;<br />
    int opp;<br />
    int next;<br />
};<br />
struct Dinic{<br />
    node arc[MAXE];<br />
    int vn, en, head[MAXV];     //vn点个数(包括源点汇点),en边个数<br />
    int cur[MAXV];              //当前弧<br />
    int q[MAXV];                //bfs建层次图时的队列<br />
    int path[MAXE], top;        //存dfs当前最短路径的栈<br />
    int dep[MAXV];              //各节点层次<br />
    void init(int n){<br />
        vn = n;<br />
        en = 0;<br />
        mem(head, -1);<br />
    }<br />
    void insert_flow(int u, int v, int flow){<br />
        arc[en].u = u;<br />
        arc[en].v = v;<br />
        arc[en].flow = flow;<br />
        arc[en].opp = en + 1;<br />
        arc[en].next = head[u];<br />
        head[u] = en ++;

        arc[en].u = v;<br />
        arc[en].v = u;<br />
        arc[en].flow = 0;       //反向弧<br />
        arc[en].opp = en - 1;<br />
        arc[en].next = head[v];<br />
        head[v] = en ++;<br />
    }<br />
    bool bfs(int s, int t){<br />
        mem(dep, -1);<br />
        int lq = 0, rq = 1;<br />
        dep[s] = 0;<br />
        q[lq] = s;<br />
        while(lq  0){<br />
                    dep[v] = dep[u] + 1;<br />
                    q[rq ++] = v;<br />
                }<br />
            }<br />
        }<br />
        return false;<br />
    }<br />
    int solve(int s, int t){<br />
        int maxflow = 0;<br />
        while(bfs(s, t)){<br />
            int i, j;<br />
            for (i = 1; i  arc[path[k]].flow){<br />
                            minflow = arc[path[k]].flow;<br />
                            mink = k;<br />
                        }<br />
                    for (int k = 0; k  outdeg[i]){<br />
                dinic.insert_flow(i, n+2, x/2);<br />
                sum += x/2;<br />
            }<br />
            else{<br />
                dinic.insert_flow(n+1, i, x/2);<br />
            }<br />
        }<br />
        if (!ok){<br />
            puts("impossible");<br />
            continue;<br />
        }<br />
        if (dinic.solve(n+1, n+2) == sum){<br />
            puts("possible");<br />
        }<br />
        else{<br />
            puts("impossible");<br />
        }<br />
    }<br />
	return 0;<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1wp49g.html">架构 Roadmap 笔记分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/495jkzvq.html">HDU2459 后缀数组&plus;RMQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkzg19.html">&lbrack;转&rsqb;常用的快速Web原型图设计工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvjpojq.html">java 调用 C&num; 类库搞定，三步即可，可以调用任何类及方法，很简单，非常爽啊</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gx6k0q.html">html页面实现自动刷新的几种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0yyxq.html">【转载】C&plus;&plus;中的位拷贝和值拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glmw7q.html">js中的getAttribute方法使用示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gnvzl8.html">SQLServer DMV Query</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdelm109.html">C&num;知识总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdmdwk8.html">winform布局格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0xj0q.html">Unit Test相关问题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpen3xq.html">Unity3d socket通信 切换到web版本时报错SecurityException解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwjn49.html">Cocos2d-x实现Android的Toast特征</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpvy1r9.html">JavaScript对象之document对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5de19.html">打造自己的Android常用知识体系</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yzp2g8.html">SQLServer删除登录帐户</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p60yn8.html">2017 CCPC Qinhuangdao Site</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp6rjzq.html">ant安装报错：ANT&lowbar;HOME is set incorrectly or ant could not be located&period; Please set ANT&lowbar;HOME&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96000lv9.html">【洛谷P3960】列队题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvn67z8.html">synchronized和lock以及synchronized和volatile的区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wglnxq.html">ARM-Linux S5PV210 UART驱动（2）---- 终端设备驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmzwo09.html">shapefile文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdn30k8.html">PS 颜色表大全-CMYK颜色表（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmzow09.html">【BZOJ 1054】 &lbrack;HAOI2008&rsqb;移动玩具</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e13d1e9.html">unity手游之聊天SDK集成与使用二</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvjx1oq.html">基于Ogre的DeferredShading（延迟渲染）的实现以及应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xz6nz8.html">&period;NET 反射详解（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x7rp08.html">vi查找替换</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3zznq.html">tomcat部署javaweb项目的三种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnzkze8.html">HDU1565&plus;状态压缩dp</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
